#ifndef _STATE_H_
#define _STATE_H_
#include "stdio.h"
#include "defs.h"
#include "video.h"

class TState {
    void Draw();
    int x, y;
  public:
    TState(int x, int y);
    ~TState();
    void Update(long step, int symvol, int move, int state);
};

TState::TState(int x, int y)
{
  TState::x = x;
  TState::y = y;
  Draw();
//  Update(0, 0, 0, 0);
}

TState::~TState()
{
}

void TState::Draw()
{
  fill(x + 1, y, 18, 1, '', STATE_COLOR);
  fill(x + 1, y + 5, 18, 1, '', STATE_COLOR);
  fill(x, y + 1, 1, 4, '', STATE_COLOR);
  fill(x + 19, y + 1, 1, 4, '', STATE_COLOR);
  out_char(x, y, '', STATE_COLOR);
  out_char(x + 19, y, '', STATE_COLOR);
  out_char(x, y + 5, '', STATE_COLOR);
  out_char(x + 19, y + 5, '', STATE_COLOR);
  out_string(x + 7, y, " State ", STATE_TITLECOLOR);
  fill(x + 1, y + 1, 18, 4, ' ' , STATE_COLOR);
  out_string(x + 2, y + 1, "Step:", STATE_TEXTCOLOR);
  out_string(x + 2, y + 2, "Symvol:", STATE_TEXTCOLOR);
  out_string(x + 2, y + 3, "Move:", STATE_TEXTCOLOR);
  out_string(x + 2, y + 4, "State:", STATE_TEXTCOLOR);
  set_attr(x + 20, y + 1, 2, 6, SHADOW_COLOR);
  set_attr(x + 2, y + 6, 20, 1, SHADOW_COLOR);
}

void TState::Update(long step, int symvol, int move, int state)
{
  char s[10];

  if (step > 0)
  {
    sprintf(s, "%8ld", step);
    out_string(x + 10, y + 1, s, STATE_TEXTCOLOR);
    sprintf(s, "%8c", symvol);
    out_string(x + 10, y + 2, s, STATE_TEXTCOLOR);
    switch (move)
    {
      case 0: sprintf(s, "%8c", 'l'); break;
      case 1: sprintf(s, "%8c", 'r'); break;
      case 2: sprintf(s, "%8c", 's'); break;
    }
    out_string(x + 10, y + 3, s, STATE_TEXTCOLOR);
    sprintf(s, "%8d", state);
    out_string(x + 10, y + 4, s, STATE_TEXTCOLOR);
  }
  else Draw();
}


#endif
