#include <conio.h>
#include <string.h>
#include "utils.h"
#include "menu.h"
#include "video.h"
#include "defs.h"
#include "tape.h"
#include "prog.h"
#include "_tape.h"
#include "kb.h"
#include "clock.h"
#include "chdir.h"

class TTuring {
  private:
    TMenu *menu;
    char *prog_name;
    TProgram *program;
    int edit;
    int run_flag;
    int trace_flag;
  public:
    TTuring(char *);
    ~TTuring();
    void DrawScreen();
    void RestoreScreen();
    void Run();
    void About();
};

TTuring::TTuring(char *filename)
{
  ShowCursor();
  strcpy(prog_name, filename);
  menu = new TMenu(1,
    NewMenuItem("~F~ile",
      NewSubMenuItem("~L~oad program  F3", 2,
      NewSubMenuItem("Load t~a~pe", 18,
      NewSubMenuItem("~S~ave program  F2", 3,
      NewSubMenuItem("Save ~t~ape", 17,
      NewSubMenuItem("~C~hange dir", 4,
      NewSubMenuItem("~Q~uit       Alt-X", 1, 0)))))),
    NewMenuItem("~E~dit",
      NewSubMenuItem("~N~ew program", 5,
      NewSubMenuItem("~E~dit program", 6,
      NewSubMenuItem("~C~lear tape", 7,
      NewSubMenuItem("Edi~t~ tape", 8,
      NewSubMenuItem("Toggle Program/Tape  F6", 15, 0))))),

    NewMenuItem("~R~un",
      NewSubMenuItem("~R~un            Ctrl-F9", 9,
      NewSubMenuItem("~S~tep                F7", 10,
      NewSubMenuItem("Toggle ~b~reak point  F8", 11,
      NewSubMenuItem("Clear all break points", 19,
      NewSubMenuItem("St~o~p                F4", 16,
      NewSubMenuItem("~P~rogram reset       F5", 12, 0)))))),
    NewMenuItem("~H~elp",
      NewSubMenuItem("~A~bout", 13,
      NewSubMenuItem("~C~ontents  F1", 14, 0)), 0)))));
  DrawScreen();
  edit = 1;
  run_flag = 0;
  trace_flag = 0;
  tape = new TTape();
  program = new TProgram();
  program -> Edit(0, 0);
}

TTuring::~TTuring()
{
  RestoreScreen();
  delete program;
  delete tape;
  delete menu;
}

void TTuring::DrawScreen()
{
  fill(0, 3, 80, 21, '', BACK_COLOR);
  fill(1, 0, 78, 1, '', MENU_COLOR);
  fill(1, 2, 78, 1, '', MENU_COLOR);
  out_char(0, 0, '', MENU_COLOR);
  out_char(79, 0, '', MENU_COLOR);
  out_char(0, 2, '', MENU_COLOR);
  out_char(79, 2, '', MENU_COLOR);
  out_char(0, 1, '', MENU_COLOR);
  out_char(79, 1, '', MENU_COLOR);
  out_string(29, 0, " The Turing Machine ", MENU_COLOR);
  set_attr(2, 3, 78, 1, SHADOW_COLOR);
  fill(0, 24, 80, 1, ' ', MENU_COLOR);
  out_hotstring(1, 24, "~F10~ Menu   ~Alt-X~ Quit", MENU_COLOR, HOT_COLOR);
}

void TTuring::RestoreScreen()
{
  gotoxy(1, 1);
  fill(0, 0, 80, 25, ' ', 0x07);
}

void TTuring::Run()
{
  char key, old_key;
  int command = 0, i;
  MessageBox("Turing", "Welcome to the\nTuring Machine!\n", 0);

  do
  {
    command = 0;

    if (run_flag) run_flag = program -> Run();

    if (kbhit())
    {
      key = getch();

      if (old_key == 0)
      switch (key)
      {
        case 68: HideCursor();
                 command = menu -> Run();
                 if (edit)
                   ShowCursor();
                 break;
        case 45: command = 1; break;
        case 64: command = 15; break;
        case 65: command = 10; break;
        case 66: command = 11; break;
        case 60: command = 3; break;
        case 61: command = 2; break;
        case 67: command = 9; break;
        case 63: command = 12; break;
        case 62: command = 16; break;
      }

      switch (command)
      {
        case  2: program -> Load(); break;
        case  3: program -> Save(); break;
        case  4: if (edit) HideCursor();
                 ChdirBox();
                 if (edit) ShowCursor();
                 break;
        case 17: tape -> Save(); break;
        case 18: tape -> Load(); break;
        case 19: program -> ClearBreakPoints(); break;
        case  9: run_flag = !(tape -> CheckEmpty()); break;
        case 10: run_flag = 0; program -> Run(); break;
        case 11: program -> Edit(255, 0); break;
        case 12: run_flag = 0; program -> Reset(); break;
        case 13: About(); break;
        case 16: run_flag = 0; break;
        case  5: program -> Clear(); break;
        case  7: tape -> Clear(); break;
        case 15: if (edit == 1)
                   edit = 2;
                 else
                   if (edit == 2)
                     edit = 1;
                 break;
        case  6: edit = 1; ShowCursor(); break;
        case  8: edit = 2; ShowCursor(); break;
        case  1: if (MessageBox("Turing", "Are you shure\nyou want to quit\nThe Turing Machine?\n", 1))
                   command = 0;
      }

      if (old_key != 0)
      {
        if (edit == 1)
          program -> Edit(0, key);
        if (edit == 2)
          tape -> Edit(0, key);
      }
      else
      {
        if (edit == 1)
          program -> Edit(key, 0);
        if (edit == 2)
          tape -> Edit(key, 0);
      }
    }

    UpdateClock();
    old_key = key;

  } while (command != 1);
}

void TTuring::About()
{
  MessageBox("About", "Turing Machine emulation.\nCopyright (c) 1999 MATI Inc.\n", 0);
}

void main(int argc, char *argv[])
{
  TTuring *t;

  if (argc > 1)
    t = new TTuring(argv[1]);
  else
    t = new TTuring("");

  t -> Run();
  delete t;
}
